import time
from pathlib import Path
from urllib.parse import urlparse

import requests

headers = {
        "user-agent": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/106.0.0.0 "
                      "YaBrowser/22.11.3.838 Yowser/2.5 Safari/537.36",
        "accept": "text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,"
                  "application/signed-exchange;v=b3;q=0.9"
    }


def download(url):
    try:
        rs = requests.get(url=url, headers=headers, stream=True, allow_redirects=True)
        if 200 <= rs.status_code <= 299:
            name = rs.headers.get('filename')
            if not name:
                name = Path(urlparse(rs.url).path).name
            with open(name, 'wb') as file:
                for part in rs.iter_content(1024):
                    file.write(part)
        else:
            return
    except Exception as ex:
        print(ex)
        return


def main():
    url = input("Введите ссылку для загрузки: ")
    t = time.time()
    download(url)
    print(f'Время загрузки файла: {time.time() - t:.2f}')


if __name__ == "__main__":
    main()
