import time
from concurrent.futures import ThreadPoolExecutor
from pathlib import Path
from urllib.parse import urlparse

import requests

headers = {
        "user-agent": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/106.0.0.0 "
                      "YaBrowser/22.11.3.838 Yowser/2.5 Safari/537.36",
        "accept": "text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,"
                  "application/signed-exchange;v=b3;q=0.9"
    }

s = requests.Session()


def get_size(url):
    name = ""
    try:
        rs = requests.head(url=url, headers=headers, allow_redirects=True)
        if 200 <= rs.status_code <= 299:
            name = rs.headers.get('filename')
            if not name:
                name = Path(urlparse(rs.url).path).name
            if rs.headers.get("Content-Length"):
                return int(rs.headers.get("Content-Length")), name
            return 0, name
    except Exception:
        return 0, name


def download(url, start, end, output):
    header = {
        "user-agent": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/106.0.0.0 "
                      "YaBrowser/22.11.3.838 Yowser/2.5 Safari/537.36",
        "accept": "text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,"
                  "application/signed-exchange;v=b3;q=0.9",
        'Range': f'bytes={start}-{end}'
    }

    try:
        rs = s.get(url=url, headers=header, stream=True, allow_redirects=True)
        if 200 <= rs.status_code <= 299:
            with open(output, 'wb') as file:
                for part in rs.iter_content(1024):
                    file.write(part)
        else:
            return
    except Exception as ex:
        print(ex)
        return


def thread_run(url, count):
    file_size, name = get_size(url)
    chunk_size = int(file_size / count)
    chunks = range(0, file_size, chunk_size)

    with ThreadPoolExecutor(max_workers=count) as executor:
        for i, chunk in enumerate(chunks):
            executor.submit(download, url=url, start=chunk, end=chunk + chunk_size - 1, output=f'{Path(url).name}.{i}')

    return len(chunks), name


def main():
    url = input("Введите ссылку для загрузки: ")
    t = time.time()
    chunks, name = thread_run(url, 3)

    with open(name, "wb") as file:
        for i in range(chunks):
            with open(f'{Path(url).name}.{i}', 'rb') as ch:
                file.write(ch.read())
            Path(f'{Path(url).name}.{i}').unlink()

    print(f'Время загрузки файла частями с потоками: {time.time() - t:.2f}')


if __name__ == "__main__":
    main()
